## ros-humble-rclc 4.0.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(rclc)

set(CMAKE_VERBOSE_MAKEFILE ON)

#################################################
# compiler settings
#################################################

# Default to C11
if(NOT CMAKE_C_STANDARD)
  set(CMAKE_C_STANDARD 11)
endif()

# Default to C++14
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic)
endif()

set(CMAKE_VERBOSE_MAKEFILE ON)

#################################################
# package dependencies
#################################################
find_package(ament_cmake_ros REQUIRED)
find_package(rcl REQUIRED)
find_package(rcl_action REQUIRED)
find_package(rcutils REQUIRED)
find_package(rosidl_generator_c REQUIRED)

if("${rcl_VERSION}" VERSION_LESS "1.0.0")
  message(STATUS
    "Found rcl version ${rcl_VERSION}, which belongs to Dashing or Eloquent")
  # Later, with CMake 3.12+ use:
  # add_compile_definitions(USE_RCL_WAIT_SET_IS_VALID_BACKPORT)
  add_definitions(-DUSE_RCL_WAIT_SET_IS_VALID_BACKPORT)
else()
  message(STATUS
    "Found rcl version ${rcl_VERSION}, which belongs to Foxy or later")
  find_package(rosidl_runtime_c REQUIRED)
endif()

#################################################
# create library
#################################################

add_library(${PROJECT_NAME}
  src/rclc/init.c
  src/rclc/publisher.c
  src/rclc/subscription.c
  src/rclc/client.c
  src/rclc/service.c
  src/rclc/timer.c
  src/rclc/action_client.c
  src/rclc/action_server.c
  src/rclc/action_goal_handle.c
  src/rclc/node.c
  src/rclc/executor_handle.c
  src/rclc/executor.c
  src/rclc/sleep.c
)
if("${rcl_VERSION}" VERSION_LESS "1.0.0")
  target_sources(${PROJECT_NAME}
    PRIVATE src/rclc/rcl_wait_set_is_valid_backport.c)
endif()

target_include_directories(${PROJECT_NAME}
    PUBLIC
        $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
        $<INSTALL_INTERFACE:include>
    PRIVATE
        $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/src>
)

target_link_libraries(${PROJECT_NAME} ${CMAKE_THREAD_LIBS_INIT})
# specific order: dependents before dependencies
ament_target_dependencies(${PROJECT_NAME}
  rcl
  rcl_action
  rcutils
  rosidl_generator_c
)

#################################################
# install
#################################################
#install(DIRECTORY include/ DESTINATION include)
#install(TARGETS ${PROJECT_NAME} DESTINATION lib)

# Causes the visibility macros to use dllexport rather than dllimport,
# which is appropriate when building the dll but not consuming it.
target_compile_definitions(${PROJECT_NAME}
  PRIVATE "RCLC_BUILDING_LIBRARY")

install(
  TARGETS ${PROJECT_NAME} EXPORT ${PROJECT_NAME}
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin
)

install(
  DIRECTORY include/
  DESTINATION include
)

# specific order: dependents before dependencies
ament_export_include_directories(include)
ament_export_libraries(${PROJECT_NAME})

if("${rcl_VERSION}" VERSION_LESS "1.1.10")
# ament_export_targets command is not available for Dashing
else()
ament_export_targets(${PROJECT_NAME})
endif()


#################################################
# gtest
#################################################
if(BUILD_TESTING)
  find_package(ament_cmake_gtest REQUIRED)
  find_package(ament_lint_auto REQUIRED)
  find_package(osrf_testing_tools_cpp REQUIRED)
  find_package(std_msgs REQUIRED)
  find_package(example_interfaces REQUIRED)
  find_package(rclcpp REQUIRED)
  find_package(rclcpp_action REQUIRED)

  # No copyright header check since link to NOTICE file is not recognized properly.
  set(ament_cmake_copyright_FOUND TRUE)

  ament_lint_auto_find_test_dependencies()

  ament_add_gtest(${PROJECT_NAME}_test
    test/rclc/test_init.cpp
    test/rclc/test_node.cpp
    test/rclc/test_publisher.cpp
    test/rclc/test_subscription.cpp
    test/rclc/test_client.cpp
    test/rclc/test_service.cpp
    test/rclc/test_timer.cpp
    test/rclc/test_executor_handle.cpp
    test/rclc/test_executor.cpp
    test/rclc/test_action_server.cpp
    test/rclc/test_action_client.cpp
  )

  target_include_directories(${PROJECT_NAME}_test PRIVATE include src)
  target_link_libraries(${PROJECT_NAME}_test ${PROJECT_NAME})
  ament_target_dependencies(${PROJECT_NAME}_test
    rclcpp
    rclcpp_action
    rcl
    rcutils
    rosidl_generator_c
    osrf_testing_tools_cpp
    std_msgs
    test_msgs
    example_interfaces
  )


endif()

#################################################
# export dependencies
#################################################
# specific order: dependents before dependencies
ament_export_include_directories(include)
ament_export_libraries(${PROJECT_NAME})
ament_export_dependencies(ament_cmake)
ament_export_dependencies(rcl)
ament_export_dependencies(rcl_action)
ament_export_dependencies(rcutils)
ament_export_dependencies(rosidl_generator_c)
ament_package()

=== debian/changelog ===
ros-humble-rclc (4.0.2-3bookworm) bookworm; urgency=high

  * Drop build dependency on std_msgs (backport #314) (#315)
  * Updated mailto:ros-tooling/setup-ros@0.4.2 and mailto:ros-tooling/action-ros-ci@0.2.7 (#318) (#320)
  * Removed build status for Galactic in README (EOL November 2022) (#321) (#322)
  * Update documentation about number_of_handles (#326) (#327)

 -- Jan Staschulat <jan.staschulat@de.bosch.com>  Tue, 21 Mar 2023 16:00:00 -0000

ros-humble-rclc (4.0.1-3bookworm) bookworm; urgency=high

  * updated documentation bloom build status table (#291) (#292)
  * updated os-version to ubuntu-22.04 (#295)
  * [rolling] updated ros-tooling versions (backport #289) (#297)
  * improved doxygen-generated API documentation (#301) (#302)

 -- Jan Staschulat <jan.staschulat@de.bosch.com>  Tue, 19 Jul 2022 16:00:00 -0000

ros-humble-rclc (4.0.0-3bookworm) bookworm; urgency=high

  * updated version for Humble release

 -- Jan Staschulat <jan.staschulat@de.bosch.com>  Wed, 27 Apr 2022 16:00:00 -0000

ros-humble-rclc (3.0.8-3bookworm) bookworm; urgency=high

  * Remove duplicate typedefs. (#249)
  * Add rmw dependencies due to EventsExecutor PR in rcl (#255)
  * Fix action client & server deallocation (#257)
  * updated documentation: build status for Rolling (#266)
  * Update action client goal callback signature (#282)
  * Upgrade parameters (#274)

 -- Jan Staschulat <jan.staschulat@de.bosch.com>  Wed, 13 Apr 2022 16:00:00 -0000

ros-humble-rclc (3.0.7-3bookworm) bookworm; urgency=high

  * Fix enum naming for avoid collision (#242)
  * Added dependency for package performance-test-fixture (#245)

 -- Jan Staschulat <jan.staschulat@de.bosch.com>  Wed, 16 Feb 2022 16:00:00 -0000

ros-humble-rclc (3.0.6-3bookworm) bookworm; urgency=high

  * executor ignore canceled timers (#220)
  * uddated documentation README.md (#229)
  * resolved error in unit test see issue #230 (#231)
  * Add thread dependency to examples (Rolling) (#237) (resolves in this package only cpplint errors)

 -- Jan Staschulat <jan.staschulat@de.bosch.com>  Mon, 24 Jan 2022 16:00:00 -0000

ros-humble-rclc (3.0.5-3bookworm) bookworm; urgency=high

  * Fix data_available reset for timer (backport #215) (#217)

 -- Jan Staschulat <jan.staschulat@de.bosch.com>  Mon, 22 Nov 2021 16:00:00 -0000

ros-humble-rclc (3.0.4-3bookworm) bookworm; urgency=high

  * Ignoring unsuccessful SERVICE_TAKE (#175)
  * Add rclc_parameter Quality Declaration (#144)
  * use-ros2-testing (#185)
  * Fix: printf in executor spin (#195)
  * Fix init options handling (#202) (#205)
  * Remove init options from support (#203)
  * RCLC Actions Implementation (#170)
  * Add rcl_action as build export dependency (#211)

 -- Jan Staschulat <jan.staschulat@de.bosch.com>  Tue, 16 Nov 2021 16:00:00 -0000

ros-humble-rclc (3.0.3-3bookworm) bookworm; urgency=high

  * Checking for valid ROS context in spin_some
  * Refactoring executor (removing callback_type)
  * Fixing codecov config

 -- Jan Staschulat <jan.staschulat@de.bosch.com>  Tue, 27 Jul 2021 16:00:00 -0000

ros-humble-rclc (3.0.2-3bookworm) bookworm; urgency=high

  * Updated codecov to ignore test folders
  * Updated bloom release status table

 -- Jan Staschulat <jan.staschulat@de.bosch.com>  Sun, 25 Jul 2021 16:00:00 -0000

ros-humble-rclc (3.0.1-3bookworm) bookworm; urgency=high

  * Added rclc_parameter package
  * Added quality of service entity creation API
  * Added executor prepare API
  * Added support for removing subscription from executor
  * Added support for subscription with context
  * Added quality declaration statement
  * Updated compatability function for sleep
  * Removed duplicate NOTICE files

 -- Jan Staschulat <jan.staschulat@de.bosch.com>  Fri, 16 Jul 2021 16:00:00 -0000

ros-humble-rclc (2.0.0-3bookworm) bookworm; urgency=high

  * Added codecov support
  * New API of rcl_lifecycle in Rolling required major version bump

 -- Jan Staschulat <jan.staschulat@de.bosch.com>  Thu, 22 Apr 2021 16:00:00 -0000

ros-humble-rclc (1.0.1-3bookworm) bookworm; urgency=high

  * Windows port
  * Compatibility sleep function (Windows, POSIX-OS)
  * Fixed RCL lifecycle API change for Rolling

 -- Jan Staschulat <jan.staschulat@de.bosch.com>  Sun, 28 Mar 2021 16:00:00 -0000

ros-humble-rclc (1.0.0-3bookworm) bookworm; urgency=high

  * Service callbacks with context
  * Fixed minor issues unit tests
  * Upgraded setup_ros action (ci jobs)
  * Removed Eloquent from ci jobs

 -- Jan Staschulat <jan.staschulat@de.bosch.com>  Wed, 03 Mar 2021 16:00:00 -0000

ros-humble-rclc (0.1.7-3bookworm) bookworm; urgency=high

  * Corrected corrupted changelog

 -- Jan Staschulat <jan.staschulat@de.bosch.com>  Tue, 19 Jan 2021 16:00:00 -0000

ros-humble-rclc (0.1.6-3bookworm) bookworm; urgency=high

  * Fixed issues due to Github Action timing delays on cloud build
  * Fixed missing package dependency in Github Action for Eloquent

 -- Jan Staschulat <jan.staschulat@de.bosch.com>  Tue, 19 Jan 2021 16:00:00 -0000

ros-humble-rclc (0.1.5-3bookworm) bookworm; urgency=high

  * Added support for services,clients and guard_conditions to rclc executor
  * Added table for bloom release status in README file

 -- Jan Staschulat <jan.staschulat@de.bosch.com>  Thu, 10 Dec 2020 16:00:00 -0000

ros-humble-rclc (0.1.4-3bookworm) bookworm; urgency=high

  * Fixed error in bloom release

 -- Jan Staschulat <jan.staschulat@de.bosch.com>  Tue, 24 Nov 2020 16:00:00 -0000

ros-humble-rclc (0.1.3-3bookworm) bookworm; urgency=high

  * Added rclc_lifecycle package
  * Change maintainer information
  * Minor fixes, updated unit tests

 -- Jan Staschulat <jan.staschulat@de.bosch.com>  Sun, 22 Nov 2020 16:00:00 -0000

ros-humble-rclc (0.1.2-3bookworm) bookworm; urgency=high

  * Fixed compiler errors for bloom release

 -- Jan Staschulat <jan.staschulat@de.bosch.com>  Mon, 18 May 2020 16:00:00 -0000

ros-humble-rclc (0.1.1-3bookworm) bookworm; urgency=high

  * Initial release



=== debian/control ===
Source: ros-humble-rclc
Section: misc
Priority: optional
Maintainer: Jan Staschulat <jan.staschulat@de.bosch.com>
Build-Depends: debhelper (>= 9.0.0), ros-humble-ament-cmake-gtest <!nocheck>, ros-humble-ament-cmake-pytest <!nocheck>, ros-humble-ament-cmake-ros, ros-humble-ament-lint-auto <!nocheck>, ros-humble-ament-lint-common <!nocheck>, ros-humble-example-interfaces <!nocheck>, ros-humble-launch-testing <!nocheck>, ros-humble-osrf-testing-tools-cpp <!nocheck>, ros-humble-rcl, ros-humble-rcl-action, ros-humble-rclcpp <!nocheck>, ros-humble-rclcpp-action <!nocheck>, ros-humble-rcutils, ros-humble-rosidl-generator-c, ros-humble-rosidl-typesupport-c, ros-humble-std-msgs <!nocheck>, ros-humble-test-msgs <!nocheck>, ros-humble-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-humble-rclc
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-humble-rcl, ros-humble-rcl-action, ros-humble-rcutils, ros-humble-rosidl-generator-c, ros-humble-ros-workspace
Description: The ROS client library in C.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/humble/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/humble" \
		-DAMENT_PREFIX_PATH="/opt/ros/humble" \
		-DCMAKE_PREFIX_PATH="/opt/ros/humble" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-humble-rclc//opt/ros/humble/lib/:$(CURDIR)/debian/ros-humble-rclc//opt/ros/humble/opt/rclc/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_install
